\begin{pspicture}(11,12.5)
\rput(0,12.5){$\tbaparent[MM]:$}
\cnodeput[linestyle=dashed](1,12.5){Pdest}{P\ref{algline:mm:dest}}
\cnodeput[doubleline=true](1,10.5){Pmaster}{P\ref{algline:mm:master}}

\ncline{->}{Pdest}{Pmaster}
\goto{\atimer[setup]=0}

\cnodeput(1,7){send1-01}{\stij{\tbaparent\ref{algline:mm:send1}}{0}{1}}

\ncline{->}{Pmaster}{send1-01}
\goto[{\atimer[send1]=0}]{\timer{\atimer[setup1]<.2}}
\cnodeput(1,3.5){send2-01}{\stij{\tbaparent\ref{algline:mm:send2}}{0}{1}}

%\cnodeput(5,7.5){P2-2}{P2-2}
\cnodeput(4.5,11){incdest01}{\stij{\tbaparent\ref{algline:mm:incdest}}{0}{1}}
\cnodeput(4.5,7){send1-10}{\stij{\tbaparent\ref{algline:mm:send1}}{1}{0}}
\cnodeput(4.5,3.5){send2-10}{\stij{\tbaparent\ref{algline:mm:send2}}{1}{0}}


\cnodeput(8.5,11){incdest10}{\tbaparent\stij{\ref{algline:mm:incdest}}{1}{0}}
\cnodeput(8.5,7){send1-11}{\stij{\tbaparent\ref{algline:mm:send1}}{1}{1}}
\cnodeput(8.5,3.5){send2-11}{\stij{\tbaparent\ref{algline:mm:send2}}{1}{1}}

%\cnodeput(9.5,7){12-11}{\stij{P12}{1}{1}}
%\cnodeput(9.5,3.5){13-11}{\stij{P13}{1}{1}}
\ncline{->}{send1-11}{send2-11}
\goto[{\atimer[send6]=0}]{\timer{\atimer[{send5}]<.3}}

%\ncline{->}{12-11}{13-11}
%\goto[{\atimer[send8]=0}]{\timer{\atimer[{send7}]<5}}
%\ncangle[angleA=0,angleB=180,arm=.5cm]{->}{send2-11}{12-11}
%\goto[{\atimer[send7]=0}]{\timer{\atimer[send6]<5}}

\cnodeput(11,8){incdest11}{\stij{\tbaparent\ref{algline:mm:incdest}}{1}{1}}
\cnodeput(11,12.5){locMM}{\tbaparent\ref{algline:mm:locMM}}
\cnodeput(6,12.5){wb}{\tbaparent\ref{algline:mm:wb}}

\ncline{->}{11-11}{incdest11}
%\ncangle[angleA=0,angleB=270]{->}{13-11}{P21}
\ncangle[angleA=0,angleB=270]{->}{send2-11}{incdest11}
\goto[{\atimer[setupMM]=0}]{\clock{}{\atimer[{send6}]<.3}{\fork{\tbachild[3]}}}
\ncline{->}{incdest11}{locMM}
\goto[{\atimer[MM]=0}]{\timer{\atimer[setupMM]<1}}

%\aput{:U}{\clock{x=0}{}{}}
\ncline{->}{send1-01}{send2-01}
\goto[{\atimer[send2]=0}]{\timer{\atimer[{send1}]<.3}}

\ncangle[angleA=0,angleB=180,arm=.75cm]{->}{send2-01}{incdest01}
\goto[{\atimer[setup2]=0}]{\clock{}{\atimer[{send2}]<.3}{\fork{\tbachild[1]}}}

\ncline{->}{P2-2}{P2-3}
%\aput{:U}{\clock{x=0}{}{}}
\ncline{->}{incdest01}{send1-10}
\goto[{\atimer[send3]=0}]{\timer{\atimer[{setup2}]<.2}}


\ncline{->}{send1-10}{send2-10}
\goto[{\atimer[send4]=0}]{\timer{\atimer[{send3}]<.3}}
\ncangle[angleA=0,angleB=180,arm=.75cm]{->}{send2-10}{incdest10}
\goto[{\atimer[setup3]=0}]{\clock{}{\atimer[{send4}]<.3}{\fork{\tbachild[2]}}}
\ncline{->}{locMM}{wb}
\dgoto [\timer{\atimer[{MM}]<1.5}] {{\atimer[reduce]=0}}
\ncline{->}{incdest10}{send1-11}
\goto[{\atimer[send5]=0}]{\timer{\atimer[{setup3}]<.2}}

\ncline{->}{wb}{Pdest}
\dgoto[\timer{\atimer[reduce]<4}]{\join{\tbachild[1],\tbachild[2],\tbachild[3]}}

%%%%%%%%%%% Child:
\rput(0,2){$\tbachild[MM]:$}
%\cnodeput(1,2){C1}{C1}
%\cnodeput(5,2){C18}{C18}
\cnodeput[linestyle=dashed](1,2){Cstart}{\tbachild\ref{algline:mm:child}}
\cnodeput(3.5,2){Crecv1}{\tbachild\ref{algline:mm:recv1}}
\cnodeput(6.5,2){Crecv2}{\tbachild\ref{algline:mm:recv2}}
\cnodeput(10,0.5){Cmm}{\tbachild\ref{algline:mm:locMM}}
\cnodeput(5,0.5){Cwb}{\tbachild\ref{algline:mm:wb}}
\cnodeput[doubleline=true](1,0.5){Cend}{\tbachild\ref{algline:mm:endwhile}}
\ncline{->}{Cstart}{Crecv1}
\goto{\atimer[recv1]=0}
\ncline{->}{Crecv1}{Crecv2}
\goto[\timer{\atimer[recv1]<.3}]{\atimer[recv2]=0}
\ncangle[angleA=0,angleB=90]{->}{Crecv2}{Cmm}
\cgoto[\timer{\atimer[recv2]<.3}]{\atimer[MM]=0}
\ncline{->}{Cmm}{Cwb}
\dgoto[\timer{\atimer[MM]<1.5}]{\atimer[reduce]=0}

\ncline{->}{Cwb}{Cend}
\dgoto[\timer{\atimer[reduce]<4}]{}

\end{pspicture}

\endinput
